#!/usr/local/bin/perl

use CGI;
$query = new CGI;

$upload_directory = "portraits";

if ($query->param('portrait')) {
    &print_page_start;
    &write_file;
    &print_success;
    &print_page_end;
}
else {
    &print_page_start;
    &print_form;
    &print_page_end;
}

sub print_page_start {
    print $query->header;
    print "<HTML><HEAD><TITLE>Portrait Upload</TITLE>\n</HEAD>\n<BODY>\n";
    print "<H1>Portrait Upload</H1>\n";
}

sub print_page_end {
    print "</BODY></HTML>\n";
}

sub print_form {
    print "<FORM ACTION=\"upload.pl\" METHOD=\"post\" ";
    print "ENCTYPE=\"multipart/form-data\">\n";
    print "<INPUT TYPE=\"file\" NAME=\"portrait\"><BR>\n";
    print "<INPUT TYPE=\"submit\" VALUE=\"upload file\"><BR>\n";
    print "</FORM>\n";
}

sub write_file {
    $filename = $query->param('portrait');
    if ($filename =~ /.*[\/\\](.*)/) {
	$out_filename = $1;
    }
    else {
	$out_filename = $filename;
    }
    $counter = 0;

    while (-e "$upload_directory/$out_filename") {
	$counter++;
	$out_filename =~ s/^(.+)\.(.+)$/$1$counter\.$2/;
    }

    open (OUTFILE, "> $upload_directory/$out_filename");
    while ($bytesread = read ($filename, $buffer, 1024)) {
	print OUTFILE $buffer;
    }
    close $filename;   
}

sub print_success {
    print "<P>The file was saved successfully.</P>\n";
}



