#!/usr/local/bin/perl

use CGI;
use CGI::Carp qw( fatalsToBrowser );
use DBI;

$query = new CGI;

$database = "rafeco_rc3";
$db_server = "db4.pair.com";
$user = "rafeco_w";
$password = "vmppa55r";


if ($query->cookie('session_id')) {
    $session_id = ($query->cookie('session_id'));
}

if ($query->param('action')) {
    if ($query->param('action') eq 'remove') {
        $page_title = "Shopping Cart";
	&db_connect;
        &remove_item;
        &print_page_start;
        &get_cart_contents;
        if ($sth->rows) {
            &print_cart;
        }
        else {
            &print_no_cart;
        }
        &print_page_end;
	&db_cleanup;
    }
}
else {
    $page_title = "Shopping Cart";
    &print_page_start;
    &db_connect;
    &get_cart_contents;
    if ($sth->rows) {
        &print_cart;
    }
    else {
        &print_no_cart;
    }
    &print_page_end;
    &db_cleanup;
}

sub db_connect {
    $dbh = DBI->connect("DBI:mysql:$database:$db_server", $user, $password);
}

sub db_cleanup {
    $rc = $sth->finish;
    $rc = $dbh->disconnect;
}

sub remove_item {
    $product_id = $query->param('product_id');
    $statement = qq[
		    delete from cart
		    where session_id = '$session_id'
		    and product_id = $product_id
		    ];
    $sth = $dbh->prepare($statement)
	or die "Couldn't prepare the query:", $sth->errstr, "\n";
    $rv = $sth->execute
	or die "Couldn't execute select statement: ", $sth->errstr, "\n";
}

sub get_cart_contents {
    $statement = qq[
		    select cart.product_id as product_id, 
		    quantity, product_name, product_price
		    from cart, products
		    where session_id = '$session_id'
		    and cart.product_id = products.product_id
		    ];
    $sth = $dbh->prepare($statement)
	or die "Couldn't prepare the query:", $sth->errstr, "\n";
    $rv = $sth->execute
	or die "Couldn't execute select statement: ", $sth->errstr, "\n";
}

sub print_cart {
    print "<CENTER>\n<TABLE>\n<TR>\n";
    print "<TH>Product ID</TH>\n<TH>Product Name</TH>\n";
    print "<TH>Price</TH>\n<TH>Quantity</TH>\n</TR>\n";
    while (@row = $sth->fetchrow_array) {
	($rec_product_id, $rec_quantity, $rec_product_name,
	 $rec_price) = @row;
        print "<TD>$rec_product_id</TD>\n";
        print "<TD>$rec_product_name</TD>\n";
        print "<TD>$rec_price</TD>\n";
        print "<TD>$rec_quantity</TD>\n";
        print "<TD>\n<FORM>\n";
        print "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"remove\">\n";
        print "<INPUT TYPE=\"hidden\" NAME=\"product_id\" ";
        print "VALUE=\"$rec_product_id\">\n";
        print "<INPUT TYPE=\"submit\" VALUE=\"remove\">\n";
        print "</TD>\n";
        print "</TR>\n";
    }
    print "</TABLE>\n";
}

sub print_page_start {
    print $query->header;
    print "<HTML>\n<HEAD>\n<TITLE>$page_title</TITLE>\n";
    print "</HEAD>\n<BODY>\n";
    print "<H1 ALIGN=\"center\">$page_title</H1>\n";
}

sub print_no_cart {
    print "<P>There are no items in your shopping cart.</P>\n";
}

sub print_page_end {
    print "<CENTER>";
    print "<P><B><A HREF=\"catalog.pl\">return to catalog</A></B></P>\n";
    print "<P><B><A HREF=\"checkout.pl\">check out</A></B></P>\n";
    print "</CENTER>";
    print "</BODY>\n</HTML>\n";
}
