#!/usr/local/bin/perl

use CGI;
$query = new CGI;

$guest_file = "guests.txt";

&print_page_start;

if ($query->param()) {
    $search_name = $query->param('search_name');

    # Wrap this code in an eval block in order to trap
    # errors.
    eval {
	open (GUESTS, "+>> $guest_file") or
	    die "Can't open $guest_file: $!";
	flock GUESTS, 2;

	seek GUESTS, 0, 0;
	my @guests = <GUESTS>;
	my @new_guests = ();

	foreach $guest (@guests) {
	    ($name, $email, $browser) = split /\t/, $guest;
	    if ($name !~ /$search_name/i) {
	        push @new_guests, $guest;
	    }
	}
	seek GUESTS, 0, 0;
	truncate GUESTS, 0;
	print GUESTS @new_guests;
	close GUESTS;

	print "Record(s) deleted.\n";
    }
}
else {
    print "<FORM>\n";
    print "<INPUT TYPE=\"text\" NAME=\"search_name\"><BR>\n";
    print "<INPUT TYPE=\"submit\">\n";
    print "</FORM>\n";
}

chomp $@;
if ($@) {
    print "ERROR: $@<BR>\n";
}

&print_page_end;

sub print_page_start {
    print $query->header;
    print "<HTML>\n<HEAD>\n<TITLE>Search for Records</TITLE>\n";
    print "</HEAD>\n<BODY>\n";
    print "<H1>Search for Records</H1>\n";
}

sub print_page_end {
    print "</BODY>\n</HTML>\n";
}

