#!/usr/local/bin/perl

use CGI;
$query = new CGI;

$guest_file = "guests.txt";
@browsers = ("Netscape", "Internet Explorer", "Opera");

&print_page_start;

if ($query->param()) {
    if (&valid_form) {
	# Create the record to be inserted
	$record = $query->param('name') . "\t";
	$record .= $query->param('email') . "\t";
	$record .= $query->param('browser') . "\n";
	
	# Wrap this code in an eval block in order to trap
	# errors.
	eval {
	    open (GUESTS, ">> $guest_file") or
		die "Can't open $guest_file: $!";
	    flock GUESTS, 2;
	    print GUESTS $record;
	    close GUESTS;
	    print "<P>New record inserted.</P>\n";
	}
    }
    else {
	&print_form;
    }
}
else {
    &print_form;
}

# If an error occurred, let the user know.
chomp $@;
if ($@) {
    print "ERROR: $@<BR>\n";
}

&print_page_end;

sub print_page_start {
    print $query->header;
    print "<HTML>\n<HEAD>\n<TITLE>Add New Record</TITLE>\n";
    print "</HEAD>\n<BODY>\n";
    print "<H1>Add New Record</H1>\n";
}

sub print_form {
    print "<P>\n<FORM>\n";
    if (!$query->param()) {
	print "Name: <INPUT TYPE=\"text\" NAME=\"name\"><BR>\n";
	print "Email: <INPUT TYPE=\"text\" NAME=\"email\"><BR>\n";
	print "Browser:<BR>";
	foreach $browser (@browsers) {
	    print "<INPUT TYPE=\"radio\" NAME=\"browser\" ";
	    print "VALUE=\"$browser\">$browser<BR>\n";
	}
    }
    else {
	print "Name: <INPUT TYPE=\"text\" NAME=\"name\" ";
	print "VALUE=\"", $query->param('name'), "\"><BR>\n";
	print "Email: <INPUT TYPE=\"text\" NAME=\"email\" ";
	print "VALUE=\"", $query->param('email'), "\"><BR>\n";
	print "Browser:<BR>";
	foreach $browser (@browsers) {
	    print "<INPUT TYPE=\"radio\" NAME=\"browser\" ";
	    print "VALUE=\"$browser\"";
	    if ($browser eq $query->param('browser')) {
		print " CHECKED";
	    }
	    print ">$browser<BR>\n";
	}
    }
    print "<INPUT TYPE=\"submit\">\n";
    print "</FORM>\n</P>\n";
}

sub valid_form {
    $return_code = 1;
    if (!$query->param('name')) {
	print "You must enter a name.<BR>\n";
	$return_code = 0;
    }
    if (!$query->param('email')) {
	print "You must enter an email address.<BR>\n";
	$return_code = 0;
    }
    if (!$query->param('browser')) {
	print "You must select a browser.<BR>\n";
	$return_code = 0;
    }
    return $return_code;
}


sub print_page_end {
    print "</BODY>\n</HTML>\n";
}

