#!/usr/local/bin/perl

use CGI;
$query = new CGI;

$guest_file = "guests.txt";
@browsers = ('Netscape', 'Internet Explorer', 'Opera');

&print_page_start;

if ($query->param()) {
    if ($query->param('new_name')) {
	if (&valid_form) {
	    # Wrap this code in an eval block in order to trap
	    # errors.
	    eval {
		open (GUESTS, "+>> $guest_file") or
		    die "Can't open $guest_file: $!";
		flock GUESTS, 2;

		seek GUESTS, 0, 0;
		my @guests = <GUESTS>;
		my @new_guests = ();

		foreach $guest (@guests) {
		    chomp $guest;
		    ($name, $email, $browser) = split /\t/, $guest;
		    if ($name eq $query->param('name') &&
			$email eq $query->param('email') &&
			$browser eq $query->param('browser')) {
			$name = $query->param('new_name');
			$email = $query->param('new_email');
			$browser = $query->param('new_browser');
			$guest = "$name\t$email\t$browser";
		    }
		    $guest .= "\n";
		    push @new_guests, $guest;
		}
		seek GUESTS, 0, 0;
		truncate GUESTS, 0;
		print GUESTS @new_guests;
		close GUESTS;
		
		print "<P>Record(s) modified.</P>\n";
		print "<A HREF=\"retrieve.pl\">Retrieve records.</A>\n";
	    }
	}
	else {
	    &print_form;
	}
    }
    else {
	&print_form;
    }
}
else {
    &print_record_list;
}

chomp $@;
if ($@) {
    print "ERROR: $@<BR>\n";
}

&print_page_end;

sub print_page_start {
    print $query->header;
    print "<HTML>\n<HEAD>\n<TITLE>Modify Records</TITLE>\n";
    print "</HEAD>\n<BODY>\n";
    print "<H1>Modify Records</H1>\n";
}

sub print_form {
    print "<P>\n<FORM>\n";
    if (!$query->param()) {
	print "Name: <INPUT TYPE=\"text\" NAME=\"new_name\"><BR>\n";
	print "Email: <INPUT TYPE=\"text\" NAME=\"new_email\"><BR>\n";
	print "Browser:<BR>";
	foreach $browser (@browsers) {
	    print "<INPUT TYPE=\"radio\" NAME=\"new_browser\" ";
	    print "VALUE=\"$browser\">$browser<BR>\n";
	}
    }
    else {
        if ($query->param('new_name')) {
	    print "Name: <INPUT TYPE=\"text\" NAME=\"new_name\" ";
	    print "VALUE=\"", $query->param('new_name'), "\"><BR>\n";
	    print "Email: <INPUT TYPE=\"text\" NAME=\"new_email\" ";
	    print "VALUE=\"", $query->param('new_email'), "\"><BR>\n";
	    print "Browser:<BR>";
	    foreach $browser (@browsers) {
		print "<INPUT TYPE=\"radio\" NAME=\"new_browser\" ";
		print "VALUE=\"$browser\"";
		if ($browser eq $query->param('new_browser')) {
		    print " CHECKED";
		}
		print ">$browser<BR>\n";
	    }
	}
	else {
	    print "Name: <INPUT TYPE=\"text\" NAME=\"new_name\" ";
	    print "VALUE=\"", $query->param('name'), "\"><BR>\n";
	    print "Email: <INPUT TYPE=\"text\" NAME=\"new_email\" ";
	    print "VALUE=\"", $query->param('email'), "\"><BR>\n";
	    print "Browser:<BR>";
	    foreach $browser (@browsers) {
		print "<INPUT TYPE=\"radio\" NAME=\"new_browser\" ";
		print "VALUE=\"$browser\"";
		if ($browser eq $query->param('browser')) {
		    print " CHECKED";
		}
		print ">$browser<BR>\n";
	    }
	}
    }
    print "<INPUT TYPE=\"hidden\" NAME=\"name\" ";
    print "VALUE=\"" . $query->param('name') . "\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"email\" ";
    print "VALUE=\"" . $query->param('email') . "\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"browser\" ";
    print "VALUE=\"" . $query->param('browser') . "\">\n";
    print "<INPUT TYPE=\"submit\" VALUE=\"Update record\">\n";
    print "</FORM>\n</P>\n";
}

sub valid_form {
    $return_code = 1;
    if (!$query->param('new_name')) {
	print "You must enter a name.<BR>\n";
	$return_code = 0;
    }
    if (!$query->param('new_email')) {
	print "You must enter an email address.<BR>\n";
	$return_code = 0;
    }
    if (!$query->param('new_browser')) {
	print "You must select a browser.<BR>\n";
	$return_code = 0;
    }
    return $return_code;
}

sub print_record_list {
    open (GUESTS, "< $guest_file") or
	die "Can't open guest file: $!";
    while (<GUESTS>) {
	chomp;
	($name, $email, $browser) = split /\t/;
	print "<P>\n";
	print "<FORM>\n";
	print "Name: $name<BR>\n";
	print "Email: $email<BR>\n";
	print "Browser: $browser<BR>\n";
	print "<INPUT TYPE=\"hidden\" NAME=\"name\" VALUE=\"$name\">\n";
	print "<INPUT TYPE=\"hidden\" NAME=\"email\" VALUE=\"$email\">\n";
	print "<INPUT TYPE=\"hidden\" NAME=\"browser\" VALUE=\"$browser\">\n";
	print "<INPUT TYPE=\"submit\" VALUE=\"Edit this entry\">\n";
	print "</FORM>\n";
	print "</P>\n";
    }
}

sub print_page_end {
    print "</BODY>\n</HTML>\n";
}


