#!/usr/local/bin/perl

use CGI;
use CGI::Carp qw( fatalsToBrowser );
use DBI;

$query = new CGI;

$database = "rafeco_rc3";
$db_server = "db4.pair.com";
$user = "rafeco_w";
$password = "vmppa55r";

if ($query->param('product_id')) {
    if ($query->cookie('session_id')) {
        $session_id = ($query->cookie('session_id'));
    }
    else {
        $session_id = time . $$;
    }
    &set_variables;
    &db_connect;
    &print_page_start;
    &add_to_cart;
    &get_products;
    &display_catalog;
    &db_cleanup;
    &print_page_end;
}
else {
    &print_page_start;
    &db_connect;
    &get_products;
    &display_catalog;
    &db_cleanup;
    &print_page_end;
}

sub add_to_cart {
    # First, make sure they don't already have the product
    # in their shopping cart.  If they don't have the cookie,
    # then it's definitely not in their shopping cart.

    if ($query->cookie('session_id')) {
	# Since they have a session, let's see if they 
	# already have the product in their cart.
	$statement = qq[
			select quantity 
			from cart
			where session_id = '$session_id'
			and product_id = $product_id];
	$sth = $dbh->prepare($statement)
	    or die "Couldn't prepare the query:", $sth->errstr, "\n";
	$rv = $sth->execute
	    or die "Couldn't execute select statement: ", $sth->errstr, "\n";
      
	# If a record was found, we need to update it.  Otherwise
	# we can just insert a new record.
	if (($rec_quantity) = $sth->fetchrow_array) {
	    $action = "update";
	}
	else {
	    $action = "insert";
	}
    }
    else {
	$action = "insert";
    }

    if ($action eq "insert") {
	$statement = qq[
			insert into cart 
			values ($session_id, $product_id, $quantity)];
	$sth = $dbh->prepare($statement)
	    or die "Couldn't prepare the query:", $sth->errstr, "\n";
	$rv = $sth->execute
	    or die "Couldn't execute insert statement: ", $sth->errstr, "\n";
    }
    else {
	$new_quantity = $quantity + $rec_quantity;
	$statement = qq[
			update cart
			set quantity = $new_quantity
			where session_id = $session_id
			and product_id = $product_id];
	$sth = $dbh->prepare($statement)
	    or die "Couldn't prepare the query:", $sth->errstr, "\n";
	$rv = $sth->execute
	    or die "Couldn't execute update statement: ", $sth->errstr, "\n";
    }
}

sub get_products {
    $statement = qq[
		    select product_id, product_name, 
		    product_desc, product_price
		    from products
		    ];
    $sth = $dbh->prepare($statement)
	or die "Couldn't prepare the query:", $sth->errstr, "\n";
    $rv = $sth->execute
	or die "Couldn't execute select statement: ", $sth->errstr, "\n";
}

sub set_variables {
    $product_id = $query->param('product_id');
    $quantity = $query->param('quantity');
}

sub db_connect {
    $dbh = DBI->connect("DBI:mysql:$database:$db_server", $user, $password);
}

sub db_cleanup {
    $rc = $sth->finish;
    $rc = $dbh->disconnect;
}

sub display_catalog {
    print "<CENTER>\n<TABLE BORDER=1 CELLPADDING=4>\n";
    print "<TR>\n<TH>Description</TH>\n<TH>Price</TH>\n</TR>\n";

    while (@row = $sth->fetchrow_array) {
        ($product_id, $product_name, $product_desc, 
	 $product_price) = @row;
        print "<TR>\n";
        print "<FORM>\n";
        print "<INPUT TYPE=\"hidden\" NAME=\"product_id\" ";
        print "VALUE=\"$product_id\">\n";
        print "<TD>$product_desc</TD>\n<TD>$product_price</TD>\n";
        print "<TD><INPUT TYPE=\"text\" NAME=\"quantity\" ";
        print "VALUE=\"1\" SIZE=2></TD>\n";
        print "<TD><INPUT TYPE=\"submit\" VALUE=\"add\"></TD>\n";
        print "</FORM>\n";
        print "</TR>\n";
    }
    print "</TABLE>\n</CENTER>\n";
}

sub print_page_start {
    if ($session_id) {
        $cookie = $query->cookie(-name=>'session_id',
                                 -value=>$session_id);
        print $query->header(-cookie=>$cookie);
    }
    else {
        print $query->header;
    }
    print "<HTML>\n<HEAD>\n<TITLE>PC Product Catalog</TITLE>\n";
    print "</HEAD>\n<BODY>\n";
    print "<H1 ALIGN=\"center\">PC Product Catalog</H1>\n";
}

sub print_page_end {
    print "<P><CENTER><B>";
    print"<A HREF=\"cart.pl\">view cart</A></B></CENTER></P>\n";
    print "</BODY>\n</HTML>\n";
}
