#!/usr/local/bin/perl

use CGI;

# Send fatal errors to browser
use CGI::Carp;

$query = new CGI;

# Set to the location of your sendmail executable
$sendmail = "/usr/sbin/sendmail -n -t -oi";

# Set to the name of the return address
$from = "webmaster\@rc3.org";

if (!$query->param()) {
    &print_page_start;
    &print_form;
    &print_page_end;
}
else {
    &set_form_vars;
    if (&valid_form eq 'yes') {
	&send_email;
	&print_page_start;
	&print_success;
	&print_page_end;
    }
    else {
	&print_page_start;
	&print_error_message;
	&print_form;
	&print_page_end;
    }
}

sub print_page_start {
    print $query->header;
    print "<HTML>\n";
    print "<HEAD>\n";
    print "<TITLE>Email Form</TITLE>\n";
    print "</HEAD>\n";
    print "<BODY>\n";
    print "<H1>Email Form</H1>\n";
}

sub print_page_end {
    print "</BODY>\n";
    print "</HTML>\n";
}

sub set_form_vars {
    $address = $query->param('address');
    $subject = $query->param('subject');
    $body = $query->param('body');
}

sub print_form {
    print "<FORM METHOD=\"post\">\n";
    print "<P>\nYour email address:\n";
    print "<INPUT TYPE=\"text\" NAME=\"address\" VALUE=\"$address\">\n";
    print "</P>\n";
    print "<P>\nEmail subject:\n";
    print "<INPUT TYPE=\"text\" NAME=\"subject\" VALUE=\"$subject\">\n";
    print "</P>\n";
    print "<P>\nEmail body:<BR>\n";
    print "<TEXTAREA NAME=\"body\" WRAP=\"physical\" ROWS=5 COLS=70>";
    print $body;
    print "</TEXTAREA>\n</P>\n";
    print "<P>\n<INPUT TYPE=\"submit\" VALUE=\"Send Email\">\n</P>\n";
    print "</FORM>\n";
}

sub valid_form {
    $success = "yes";
    if (!$subject) {
	$subject_error = "<P>You need to enter a subject ";
	$subject_error .= "for your message.</P>\n";
	$success = "no";
    }
    if (!$address) {
	$address_error = "<P>You need to specify a recipient for ";
	$address_error .= "the message.</P>\n";
	$success = "no";
    }
    if ($address !~ /^[\w-.]+\@[\w-.]+$/) {
	$address_error = "<P>The email address you entered is invalid, ";
	$address_error .= "please enter a valid address. </P>\n";
	$success = "no";
    }
    if (!$body) {
	$body_error = "<P>You need to enter some text in the ";
	$body_error .= "body of your message.</P>\n";
	$success = "no";
    }
    return $success;
}

sub print_error_message {
    if ($address_error) {
	print $address_error, "\n";
    }
    if ($subject_error) {
	print $subject_error, "\n";
    }
    if ($body_error) {
	print $body_error, "\n";
    }
}

sub print_success {
    print "<P>An email with the subject \"$subject\" was sent to ";
    print "$address.</P>\n";
}

sub send_email {
    open(MAIL, "| $sendmail") or
	die "Couldn't open sendmail: ";
    print MAIL <<EOF;
From: $from
To: $address
Subject: $subject

$body

EOF
    close MAIL;
}
